#include <limits.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>


//#define  ACCUM_SIZE  16   // Passed in as -D gcc parameter. (Min=9, Max=64) Bit width of generated random numbers.
//#define  CONSTANT_A  11   // Passed in as -D gcc parameter.
//#define  CONSTANT_B  2   // Passed in as -D gcc parameter.
//#define  CONSTANT_C  6   // Passed in as -D gcc parameter.


#define  ACCUM_MASK  (((1UL<<(ACCUM_SIZE-1))-1)<<1|1)   // Bit of a shuffle to work on all 64 bits :)


// Seed the state array.  Seed MUST not be all zero.
static uint64_t  s[2] = {1, 0};


static inline  uint64_t rotl(uint64_t value, int shift) {
	return ((value << shift) | ((value & ACCUM_MASK) >> (ACCUM_SIZE - shift))) & ACCUM_MASK;
}


static uint64_t  next(void) {
	uint64_t  s0 = s[0];
	uint64_t  s1 = s[1];
	uint64_t  result = (s0 + s1) & ACCUM_MASK;

	s1 ^= s0;
	s[0] = rotl(s0, CONSTANT_A) ^ s1 ^ (s1 << CONSTANT_B) & ACCUM_MASK;
	s[1] = rotl(s1, CONSTANT_C);

	return result;
}


//  Store only most significant bit of generated numbers.
int  main(int argc, char* argv[])
{
	uint64_t  random64;
	int  i = 0;
	uint8_t  k = 0;


	// Print some randomness
	while(1)
	{
		k = 0;

		for( i = 0; i < 8; i++ )
		{
			random64 = next();
//			printf( "%016lx ", random64 );
			k |= ((random64 >> (ACCUM_SIZE-1)) & 1) << i;
		}

		putchar( k );
	}

	return 0;
}
